def trilaterate(points, distances):
    x1, y1 = points[0]
    x2, y2 = points[1]
    x3, y3 = points[2]

    r1, r2, r3 = distances

    A = 2 * (x2 - x1)
    B = 2 * (y2 - y1)
    C = 2 * (x3 - x1)
    D = 2 * (y3 - y1)

    E = r1 ** 2 - r2 ** 2 - x1 ** 2 + x2 ** 2 - y1 ** 2 + y2 ** 2
    F = r1 ** 2 - r3 ** 2 - x1 ** 2 + x3 ** 2 - y1 ** 2 + y3 ** 2

    try:
        x = (A * E - F * C) / (A * D - B * C)
        y = (E * D - B * F) / (A * D - B * C)
    except ZeroDivisionError:
        return None  

    return x, y
